<script>
import { minValue, required, requiredIf } from 'vuelidate/lib/validators';
import { settingService } from '../../../services'
import { error_message, success_message } from '../../../Helper/helper';
import dropzonePopup from '../../../components/dropzone-popup.vue';
import config from '../../../config';
import { routes } from '../../../config/api_routes'

export default {
    components:{dropzonePopup},
  data() {
    return {
        config:config,
        owner_pem_delete_url:routes.removeIOSPemApi,
        customer_pem_image:'',
        owner_pem_image:'',
        driver_pem_image:'',
        setting: {
            google_map_key:'',
            google_map_api_key:'',
            system_latitude:'',
            system_longitude:'',
            customer_pem:'',
            owner_pem:'',
            driver_pem:'',
            notification_server_key:'',
            sendgrid_key:''
        },
    };
  },
  mounted(){
    this.getSetting();
  },
  validations:{
    setting: {
        google_map_key:{
            required
        },
        google_map_api_key:{
            required
        },
        system_latitude:{
            required
        },
        system_longitude:{
            required
        },
        customer_pem:{
            required
        },
        owner_pem:{
            required
        },
        driver_pem:{
            required
        },
        notification_server_key:{
            required
        },
        sendgrid_key:{
            required
        },
    },

  },
  methods: {
    getSetting(){
        settingService.getSetting().then((response) => {
            if (response.data.code === 200) {
                this.setting.google_map_key = response.data.result.google_map_key??'',
                this.setting.google_map_api_key = response.data.result.google_map_api_key??'',
                this.setting.system_latitude = response.data.result.system_latitude??'',
                this.setting.system_longitude = response.data.result.system_longitude??'',
                this.setting.customer_pem = response.data.result.customer_pem??'',
                this.setting.owner_pem = response.data.result.owner_pem??'',
                this.setting.driver_pem = response.data.result.driver_pem??'',
                this.setting.notification_server_key = response.data.result.notification_server_key??'',
                this.setting.sendgrid_key =response.data.result.sendgrid_key?? ''
                this.customer_pem_image = response.data.result.customer_pem??''
                this.owner_pem_image = response.data.result.owner_pem??''
                this.driver_pem_image = response.data.result.driver_pem??''
            } else {
                error_message(response.data.message);
            }
        })
    },
    onCustomerPemdeleted(key){
        settingService.deleteGeneralSettingByKey({key:key}).then((response) => {
            if (response.data.code === 200) {
                this.getSetting()
            } else {
                error_message(response.data.message);
            }
        });

    },
    fromSubmit(){
        this.$v.setting.$touch()
        if(this.$v.setting.$invalid){
            return false;
        }else{
            settingService.updateSetting({data:this.setting}).then((response) => {
                if (response.data.code === 200) {
                    success_message(response.data.message);
                    this.getSetting()
                } else {
                    error_message(response.data.message);
                }
            })
        }
    },
  },

};
</script>

<template>
    <div>
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <form @submit.prevent="fromSubmit">
                            <!-- Google Map -->
                            <div class="row">
                                <div class="col-md-4">
                                    <h5>{{ trans.get('__JSON__.Google Map') }}</h5>
                                </div>
                                <div class="col-md-8">
                                    <!-- Google Map Key -->
                                    <div class="row">
                                        <div class="col-md-12">
                                            <h6>{{ trans.get('__JSON__.Google Map Key') }}</h6>
                                        </div>
                                        <div class="col-md-6">
                                            <input type="text" class="form-control" 
                                            v-model="$v.setting.google_map_key.$model"
                                            :class="{'is-invalid' : $v.setting.google_map_key.$error}"
                                            >
                                            <div v-if="$v.setting.google_map_key.$error" class="invalid-feedback">
                                                <span v-if="!$v.setting.google_map_key.required">
                                                    {{ trans.get('__JSON__.This field is required') }}
                                                </span>
                                            </div>
                                        </div>
                                    </div>
                                    <!-- Google Map API Key -->
                                    <div class="row mt-3">
                                        <div class="col-md-12">
                                            <h6>{{ trans.get('__JSON__.Google Map API Key') }}</h6>
                                        </div>
                                        <div class="col-md-6">
                                            <input type="text" class="form-control" 
                                            v-model="setting.google_map_api_key"
                                            :class="{'is-invalid' : $v.setting.google_map_api_key.$error}"
                                            >
                                            <div v-if="$v.setting.google_map_api_key.$error" class="invalid-feedback">
                                                <span v-if="!$v.setting.google_map_api_key.required">
                                                    {{ trans.get('__JSON__.This field is required') }}
                                                </span>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row mt-3">
                                        <!-- Latitude -->
                                        <div class="col-md-6">
                                            <h6>{{ trans.get('__JSON__.Latitude') }}</h6>
                                            <input type="text" class="form-control" 
                                            v-model="setting.system_latitude"
                                            :class="{'is-invalid' : $v.setting.system_latitude.$error}"
                                            >
                                            <div v-if="$v.setting.system_latitude.$error" class="invalid-feedback">
                                                <span v-if="!$v.setting.system_latitude.required">
                                                    {{ trans.get('__JSON__.This field is required') }}
                                                </span>
                                            </div>
                                        </div>
                                        <!-- Longitude -->
                                        <div class="col-md-6">
                                            <h6>{{ trans.get('__JSON__.Longitude') }}</h6>
                                            <input type="text" class="form-control" 
                                            v-model="setting.system_longitude"
                                            :class="{'is-invalid' : $v.setting.system_longitude.$error}"
                                            >
                                            <div v-if="$v.setting.system_longitude.$error" class="invalid-feedback">
                                                <span v-if="!$v.setting.system_longitude.required">
                                                    {{ trans.get('__JSON__.This field is required') }}
                                                </span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <hr>
                            <!-- Push Notifications -->
                            <div class="row mt-4">
                                <div class="col-md-4">
                                    <h5>{{ trans.get('__JSON__.Push Notifications') }}</h5>
                                </div>
                                <div class="col-md-8">
                                    <h6>{{ trans.get('__JSON__.Pem Files (iOS Application)')}}</h6>
                                    <div class="row mt-3">
                                        <div class="col-md-4">
                                            <p>{{ trans.get('__JSON__.Customer Application')}}</p>
                                            <dropzone-popup
                                                :readonly="
                                                !$auth.hasPermission(
                                                    config.permissions.setting_Write
                                                )
                                                "
                                                v-model="setting.customer_pem"
                                                id="customer_pem"
                                                acceptedFiles=".pem"
                                                deleted_dialog="yes"
                                                :pem-delete="true"
                                                :media-path="setting.pem_url"
                                                :delete-path="owner_pem_delete_url"
                                                @image-deleted="onCustomerPemdeleted('customer_pem')"
                                                :class="{'is-invalid' : $v.setting.customer_pem.$error}"
                                                />
                                                <div v-if="$v.setting.customer_pem.$error" class="invalid-feedback">
                                                    <span v-if="!$v.setting.customer_pem.required">
                                                        {{ trans.get('__JSON__.This field is required') }}
                                                    </span>
                                                </div>
                                        </div>
                                        <div class="col-md-4">
                                            <p>{{ trans.get('__JSON__.Merchant Application')}}</p>
                                            <dropzone-popup
                                                :readonly="
                                                !$auth.hasPermission(
                                                    config.permissions.setting_Write
                                                )
                                                "
                                                v-model="setting.owner_pem"
                                                id="owner_pem"
                                                acceptedFiles=".pem"
                                                deleted_dialog="yes"
                                                :pem-delete="true"
                                                :media-path="setting.pem_url"
                                                :delete-path="owner_pem_delete_url"
                                                @image-deleted="onCustomerPemdeleted('owner_pem')"
                                                :class="{'is-invalid' : $v.setting.owner_pem.$error}"
                                                />
                                                <div v-if="$v.setting.owner_pem.$error" class="invalid-feedback">
                                                    <span v-if="!$v.setting.owner_pem.required">
                                                        {{ trans.get('__JSON__.This field is required') }}
                                                    </span>
                                                </div>

                                        </div>
                                        <div class="col-md-4">
                                            <p>{{ trans.get('__JSON__.Driver Application')}}</p>
                                            <dropzone-popup
                                                :readonly="
                                                !$auth.hasPermission(
                                                    config.permissions.setting_Write
                                                )
                                                "
                                                v-model="setting.driver_pem"
                                                id="driver_pem"
                                                acceptedFiles=".pem"
                                                deleted_dialog="yes"
                                                :pem-delete="true"
                                                :delete-path="owner_pem_delete_url"
                                                @image-deleted="onCustomerPemdeleted('driver_pem')"
                                                :class="{'is-invalid' : $v.setting.driver_pem.$error}"
                                                />
                                                <div v-if="$v.setting.driver_pem.$error" class="invalid-feedback">
                                                    <span v-if="!$v.setting.driver_pem.required">
                                                        {{ trans.get('__JSON__.This field is required') }}
                                                    </span>
                                                </div>

                                        </div>
                                    </div>
                                    <!-- Notification Server Key (Android) -->
                                    <div class="row mt-3">
                                        <div class="col-md-12">
                                            <h6>{{ trans.get('__JSON__.Notification Server Key (Android)')}}</h6>
                                        </div>
                                        <div class="col-md-6">
                                            <input type="text" class="form-control" 
                                            v-model="setting.notification_server_key"
                                            :class="{'is-invalid' : $v.setting.notification_server_key.$error}"
                                            />
                                            <div v-if="$v.setting.notification_server_key.$error" class="invalid-feedback">
                                                <span v-if="!$v.setting.notification_server_key.required">
                                                    {{ trans.get('__JSON__.This field is required') }}
                                                </span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <hr>
                            <div class="row mt-4">
                                <div class="col-md-4">
                                    <h5>{{ trans.get('__JSON__.Mail Setup')}}</h5>
                                </div>
                                <div class="col-md-8">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <h6>{{ trans.get('__JSON__.Sendgrid Key')}}</h6>
                                        </div>
                                        <div class="col-md-6">
                                            <input type="text" class="form-control" 
                                            v-model="setting.sendgrid_key"
                                            :class="{'is-invalid' : $v.setting.sendgrid_key.$error}"
                                            />
                                            <div v-if="$v.setting.sendgrid_key.$error" class="invalid-feedback">
                                                <span v-if="!$v.setting.sendgrid_key.required">
                                                    {{ trans.get('__JSON__.This field is required') }}
                                                </span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <hr>
                            <button type="submit" class="form-controle btn btn-primary">
                                {{ trans.get('__JSON__.Update') }}
                            </button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

